var http = require('http');
var setup = require('proxy');
var requestUrls = [];

var scriptErrorCode = [
  '<script>',
  'window.__kommando_js_errors = [];',
  'window.onerror = function(errorMsg, url, lineNumber) {',
  '  window.__kommando_js_errors.push(',
  '    errorMsg + " (found at " + url + ", line " + lineNumber + ")"',
  '  );',
  '};',
  '</script>'
];

var server = http.createServer();
server.on('request', function(request, response) {
  requestUrls.push(request.url);
  request.headers['Accept-Encoding'] = 'gzip;q=0,deflate,sdch';
  
  var _write = response.write;
  var _writeHead = response.writeHead;

  console.log(request.url);

  response.writeHead = function(statusCode, reasonPhrase, headers) {
    var responseHeaders = typeof reasonPhrase === 'string' ? headers : reasonPhrase;
    /*if (request.url === 'http://the-internet.herokuapp.com/javascript_error') {
      responseHeaders['content-length'] = parseInt(responseHeaders['content-length'], 10) + scriptErrorCode.join('\n').length;
    }*/
    if (request.url === 'http://the-internet.herokuapp.com/javascript_error' && responseHeaders) {
      delete responseHeaders['content-length'];
    }
    _writeHead.call(response, statusCode, responseHeaders);
  };

  response.write = function (data) {
    if (request.url === 'http://the-internet.herokuapp.com/javascript_error') {
      _write.call(response, data.toString().replace(/<head>/, '<head>' + scriptErrorCode.join('\n')));
    } else {
      _write.apply(response, arguments);
    }
  };
});

setup(server);
server.listen(5556, function () {
  var port = server.address().port;
  done = true;
});
